Index: /trunk/Makefile
===================================================================
--- /trunk/Makefile	(revision 144)
+++ /trunk/Makefile	(revision 145)
@@ -41,5 +41,5 @@
 	cp ./Server/tewi $(PREFIX)/bin/
 	cp ./Module/*.so $(PREFIX)/lib/tewi/
-	cp ./Manpage/tewi.conf.5 $(PREFIX)/share/man/man5/
+	cp ./Manpage/tewi.8 $(PREFIX)/share/man/man8/
 
 format:
Index: /trunk/Manpage/Makefile
===================================================================
--- /trunk/Manpage/Makefile	(revision 144)
+++ /trunk/Manpage/Makefile	(revision 145)
@@ -3,9 +3,9 @@
 .PHONY: all clean
 
-all: tewi.conf.5
+all: tewi.8
 
-tewi.conf.5: tewi.conf.5.tmpl
-	sed "s%@PREFIX@%$(PREFIX)%g" tewi.conf.5.tmpl > $@ || rm -f $@
+tewi.8: tewi.8.tmpl
+	sed "s%@PREFIX@%$(PREFIX)%g" tewi.8.tmpl > $@ || rm -f $@
 
 clean:
-	rm -f tewi.conf.5
+	rm -f tewi.8
Index: /trunk/Manpage/tewi.8.tmpl
===================================================================
--- /trunk/Manpage/tewi.8.tmpl	(revision 145)
+++ /trunk/Manpage/tewi.8.tmpl	(revision 145)
@@ -0,0 +1,96 @@
+\" $Id$
+.Dd 2024 Sep 16th
+.Dt TEWI 8
+.Os
+.Sh NAME
+.Nm tewi ,
+.Nm tewi.conf
+.Nd Tewi HTTPd
+.Sh DESCRIPTION
+.Nm
+is a simple public domain HTTP daemon written in C.
+.Sh CONFIGURATION
+.Ss "General settings"
+.Bl -tag -width 20 -compact
+.It Pa "Listen"
+Specifies the port(s) to be listened on.
+.It Pa "ServerRoot"
+Specifies the server root.
+.It Pa "ServerAdmin"
+Specifies the server admin.
+.It Pa "DocumentRoot"
+Specifies the document root.
+.It Pa "LoadModule"
+Loads the module.
+.It Pa "HidePort" "ShowPort"
+Shows/Hides the port in directory listing, and the default error page.
+.It Pa "MIMEType"
+Specifies the MIME type for files.
+\fBall\fR can be used instead of the extension if you want to make all extensions appear as same MIME.
+Later rules will override the MIME.
+
+Example:
+
+.Vb 1
+\&    MIMEType all application/octet-stream
+
+\&    MIMEType .html text/html
+.Ve
+
+.It Pa "BeginVirtualHost"
+Begins the virtual host section.
+.It Pa "EndVirtualHost"
+Ends the virtual host section.
+.El
+.Ss "TLS/SSL settings"
+.Bl -tag -width 20 -compact
+.It Pa "ListenSSL"
+Specifies the port(s) to be listened on, but with TLS/SSL.
+.It Pa "SSLKey"
+Specifies the TLS/SSL private key.
+This works in the virtual host section too, and can be used to switch key depending on the virtual host.
+.It Pa "SSLCertificate"
+Specifies the TLS/SSL certificate.
+This works in the virtual host section too, and can be used to switch certificate depending on the virtual host.
+.El
+.Ss "Access settings"
+.Bl -tag -width 20 -compact
+Default access is "Deny all".
+
+.It Pa "BeginDirectory"
+Begins the directory section.
+.It Pa "EndDirectory"
+Ends the directory section.
+.It Pa "Allow"
+Allows the connection. Only works with \fBall\fR for now.
+Will not work outside of the directory section.
+.It Pa "Deny"
+Denies the connection. Only works with \fBall\fR for now.
+Will not work outside of the directory section.
+.El
+.Ss "Directory settings"
+.Bl -tag -width 20 -compact
+.It Pa "DirectoryIndex"
+Specifies the directory index.
+.It Pa "Readme"
+Specifies the README file for directory listing.
+.It Pa "Icon"
+Sets the icon for the MIME type.
+\fBall\fR can be used instead of the MIME if you want to make all MIMEs appear as same icon.
+Later rules will override the icon.
+
+Example:
+
+.Vb 1
+\&    Icon all /icons/unknown.png
+
+\&    Icon text/* /icons/text.png
+.Ve
+.El
+.Sh FILES
+.Bl -tag -width @PREFIX@/etc/tewi.conf -compact
+.It Pa @PREFIX@/etc/tewi.conf
+Default path for the config
+.El
+.Sh AUTHORS
+.An Nishi Aq Mt nishi@nishi.boats
Index: unk/Manpage/tewi.conf.5.tmpl
===================================================================
--- /trunk/Manpage/tewi.conf.5.tmpl	(revision 144)
+++ 	(revision )
@@ -1,96 +1,0 @@
-\" $Id$
-.Dd 2024 Sep 16th
-.Dt TEWI 8
-.Os
-.Sh NAME
-.Nm tewi ,
-.Nm tewi.conf
-.Nd Tewi HTTPd
-.Sh DESCRIPTION
-.Nm
-is a simple public domain HTTP daemon written in C.
-.Sh CONFIGURATION
-.Ss "General settings"
-.Bl -tag -width 20 -compact
-.It Pa "Listen"
-Specifies the port(s) to be listened on.
-.It Pa "ServerRoot"
-Specifies the server root.
-.It Pa "ServerAdmin"
-Specifies the server admin.
-.It Pa "DocumentRoot"
-Specifies the document root.
-.It Pa "LoadModule"
-Loads the module.
-.It Pa "HidePort" "ShowPort"
-Shows/Hides the port in directory listing, and the default error page.
-.It Pa "MIMEType"
-Specifies the MIME type for files.
-\fBall\fR can be used instead of the extension if you want to make all extensions appear as same MIME.
-Later rules will override the MIME.
-
-Example:
-
-.Vb 1
-\&    MIMEType all application/octet-stream
-
-\&    MIMEType .html text/html
-.Ve
-
-.It Pa "BeginVirtualHost"
-Begins the virtual host section.
-.It Pa "EndVirtualHost"
-Ends the virtual host section.
-.El
-.Ss "TLS/SSL settings"
-.Bl -tag -width 20 -compact
-.It Pa "ListenSSL"
-Specifies the port(s) to be listened on, but with TLS/SSL.
-.It Pa "SSLKey"
-Specifies the TLS/SSL private key.
-This works in the virtual host section too, and can be used to switch key depending on the virtual host.
-.It Pa "SSLCertificate"
-Specifies the TLS/SSL certificate.
-This works in the virtual host section too, and can be used to switch certificate depending on the virtual host.
-.El
-.Ss "Access settings"
-.Bl -tag -width 20 -compact
-Default access is "Deny all".
-
-.It Pa "BeginDirectory"
-Begins the directory section.
-.It Pa "EndDirectory"
-Ends the directory section.
-.It Pa "Allow"
-Allows the connection. Only works with \fBall\fR for now.
-Will not work outside of the directory section.
-.It Pa "Deny"
-Denies the connection. Only works with \fBall\fR for now.
-Will not work outside of the directory section.
-.El
-.Ss "Directory settings"
-.Bl -tag -width 20 -compact
-.It Pa "DirectoryIndex"
-Specifies the directory index.
-.It Pa "Readme"
-Specifies the README file for directory listing.
-.It Pa "Icon"
-Sets the icon for the MIME type.
-\fBall\fR can be used instead of the MIME if you want to make all MIMEs appear as same icon.
-Later rules will override the icon.
-
-Example:
-
-.Vb 1
-\&    Icon all /icons/unknown.png
-
-\&    Icon text/* /icons/text.png
-.Ve
-.El
-.Sh FILES
-.Bl -tag -width @PREFIX@/etc/tewi.conf -compact
-.It Pa @PREFIX@/etc/tewi.conf
-Default path for the config
-.El
-.Sh AUTHORS
-.An Nishi Aq Mt nishi@nishi.boats