Index: /trunk/Platform/vc6.mk
===================================================================
--- /trunk/Platform/vc6.mk	(revision 248)
+++ /trunk/Platform/vc6.mk	(revision 249)
@@ -14,3 +14,3 @@
 LIBSUF = .dll
 OBJ = obj
-PREOBJS = tewi_vc6.res gui_vc6.res
+PREOBJS = vc6.res
Index: /trunk/Server/Makefile
===================================================================
--- /trunk/Server/Makefile	(revision 248)
+++ /trunk/Server/Makefile	(revision 249)
@@ -49,7 +49,4 @@
 	$(WINDRES) tewi.rc -O coff -o $@
 
-tewi_vc6.res: tewi.rc ../Binary/tewi.ico
-	rc /fo$@ tewi.rc
-
 tewi_bcc.res: tewi.rc ../Binary/tewi.ico
 	brc32 -r -fo$@ tewi.rc
@@ -58,10 +55,12 @@
 	$(WINDRES) gui.rc -O coff -o $@
 
-gui_vc6.res: gui.rc gui.h
-	rc /fo$@ gui.rc
-
 gui_bcc.res: gui.rc gui.h
 	brc32 -r -fo$@ gui.rc
 
+vc6.res: tewi.rc gui.rc
+	cat tewi.rc gui.rc > concat.rc
+	rc /fo$@ concat.rc
+	rm -f concat.rc
+
 clean:
-	rm -f *.o tewi *.exe *.res *.elf *.sfo *.pbp *.self *.pkg *.obj
+	rm -f *.o tewi *.exe *.res *.elf *.sfo *.pbp *.self *.pkg *.obj concat.rc
Index: /trunk/Server/gui.c
===================================================================
--- /trunk/Server/gui.c	(revision 248)
+++ /trunk/Server/gui.c	(revision 249)
@@ -60,4 +60,8 @@
 		ShowBitmapSize(hWnd, hdc, "TEWILOGO", size.left, size.top, WINWIDTH(size), WINWIDTH(size));
 		EndPaint(hWnd, &ps);
+	}else if(msg == WM_CTLCOLORDLG || msg == WM_CTLCOLORSTATIC){
+		HDC dc = (HDC)wp;
+		SetBkMode(dc, TRANSPARENT);
+		return GetSysColorBrush(COLOR_MENU);
 	}else{
 		return FALSE;
@@ -80,5 +84,5 @@
 		if(trig == GUI_BUTTON_ABOUT){
 			if(ev == BN_CLICKED){
-				DialogBox(hInst, "VERSIONDLG", hWnd, VersionDialog);
+				DialogBox(hInst, "VERSIONDLG", hWnd, (DLGPROC)VersionDialog);
 			}
 		}else if(trig == GUI_BUTTON_START){
Index: /trunk/Server/gui.rc
===================================================================
--- /trunk/Server/gui.rc	(revision 248)
+++ /trunk/Server/gui.rc	(revision 249)
@@ -5,5 +5,5 @@
 #include "tw_version.h"
 
-PBTEWI BITMAP "../Binary/pbtewi.bmp"
+PBTEWI BITMAP "..\\Binary\\pbtewi.bmp"
 TEWILOGO BITMAP "../Binary/tewi.bmp"
 
@@ -12,7 +12,6 @@
 CAPTION "Version Information"
 {
-	LTEXT "Tewi HTTPd version " TW_VERSION, GUI_TEWI_NAME, 42, 5, 192, 50
+	LTEXT TW_VERSION_TEXT, GUI_TEWI_NAME, 42, 5, 192, 50
 	LTEXT "Original by Nishi <nishi@nishi.boats>", GUI_TEWI_ORIGINAL, 42, 5 + 8, 192, 50
-	LTEXT "Compilation date: " __DATE__ " " __TIME__, GUI_TEWI_DATE, 42, 5 + 8 + 8, 192, 50
 	DEFPUSHBUTTON "&OK", IDOK, 75, 35, 50, 10
 }
Index: /trunk/Server/main.c
===================================================================
--- /trunk/Server/main.c	(revision 248)
+++ /trunk/Server/main.c	(revision 249)
@@ -8,4 +8,5 @@
 
 #pragma resource "tewi_bcc.res"
+
 #pragma resource "gui_bcc.res"
 
Index: /trunk/Server/tw_version.h
===================================================================
--- /trunk/Server/tw_version.h	(revision 248)
+++ /trunk/Server/tw_version.h	(revision 249)
@@ -9,4 +9,5 @@
 
 #define TW_VERSION "2.03D\0"
+#define TW_VERSION_TEXT "Tewi HTTPd version 2.03D"
 
 const char* tw_get_version(void);
Index: /trunk/Tool/option.c
===================================================================
--- /trunk/Tool/option.c	(revision 248)
+++ /trunk/Tool/option.c	(revision 249)
@@ -54,4 +54,5 @@
 #ifdef BUILD_GUI
 			printf(" -lcomctl32");
+			printf(" -luser32");
 #endif
 		}else if(strcmp(argv[3], "WINDOWS_WATCOM") == 0){
@@ -63,4 +64,5 @@
 #ifdef BUILD_GUI
 			printf(" comctl32.lib");
+			printf(" user32.lib");
 #endif
 		}
Index: /trunk/bcc.sh
===================================================================
--- /trunk/bcc.sh	(revision 248)
+++ /trunk/bcc.sh	(revision 249)
@@ -29,8 +29,10 @@
 		options="$options -tWD"
 		shared=1
+	elif [ "$i" = "-mwindows" ]; then
+		options="$options -tW"
 	elif [ "`echo "$i" | grep -Eo "^-D"`" = "-D" ]; then
 		options="$options -`echo "$i" | sed "s/^-//g"`"
 	elif [ "`echo "$i" | grep -Eo "^-l"`" = "-l" ]; then
-		if [ ! "$i" = "-lwsock32" ]; then
+		if [ ! "$i" = "-lwsock32" -a ! "$i" = "-luser32" -a ! "$i" = "-lcomctl32" ]; then
 			libraries="$libraries `echo "$i" | sed "s/^-l//g"`.lib"
 		fi
Index: /trunk/vc6.sh
===================================================================
--- /trunk/vc6.sh	(revision 248)
+++ /trunk/vc6.sh	(revision 249)
@@ -7,4 +7,5 @@
 options="/I../VC6Compat"
 obj=0
+win=0
 source=""
 libraries=""
@@ -27,7 +28,12 @@
 	elif [ "$i" = "-shared" ]; then
 		options="$options /LD"
+	elif [ "$i" = "-mwindows" ]; then
+		win=1
 	elif [ "`echo "$i" | grep -Eo "^-D"`" = "-D" ]; then
 		options="$options /`echo "$i" | sed "s/^-//g"`"
 	elif [ "`echo "$i" | grep -Eo "^-l"`" = "-l" ]; then
+		if [ "$i" = "-luser32" ]; then
+			libraries="$libraries gdi32.lib"
+		fi
 		libraries="$libraries `echo "$i" | sed "s/^-l//g"`.lib"
 	elif [ "$dowhat" = "output" ]; then
@@ -49,4 +55,9 @@
 	link="/link /nodefaultlib:libc $libraries"
 fi
+if [ "$obj" = "0" ]; then
+	if [ "$win" = "1" ]; then
+		link="$link /SUBSYSTEM:windows"
+	fi
+fi
 construct="cl /nologo $options $source $link"
 echo "Run: $construct"